-- Cecho Scripts and 2spooky Command - s_house 2.2 Port

COM_AddCommand("2spooky", function(player)
	if not (player and player.valid) then return end
	S_ChangeMusic("MAP99M", true)
end, COM_LOCAL)

-- 2.2.14 completely broke using the wait command in a SOC script,
-- so we use a different system for delaying cecho commands

local HOUSE_SCRIPTS = {
	[1] = {
		{"cecho \"Not everything is always as it appears.\""}
	},
	[2] = {
		{"cecho \"Feeling lost?\""}
	},
	[3] = {
		{"cecho \"We watch from behind the walls.\""}
	},
	[5] = {
		{"cecho \"We are all spirits, trapped and bound\\within these wall, begging and hurting\\ for release.\"", 175},
		{"cecho \"Can you free us from our torment?\\Judge us worthy of new life?\\Forgive our crimes, our sins?\"", 175},
		{"cecho \"We are a colorful bunch.\\Some are murderers, others priests.\"", 175},
		{"cecho \"Some teach tolerance,\\while others preach ignorance.\"", 175},
		{"cecho \"We are many, and we are weary.\\ We wish to be freed from our shackles.\"", 175},
		{"cecho \"But the house demands a price\\for its captives, its prisoners.\"", 175},
		{"cecho \"In order to free the unwilling,\\one must willingly take their place.\"", 175},
		{"cecho \"Do you consider us all worthy of\\a second chance?\\And are you willing to take our\\place as the eternal prisoner?\"", 175}
	},
	[20] = {
		{"cecho \"We do not blame you for leaving.\\How could we?\\There is no debt that you owe us,\\no reason to feel\\compelled to take our place.\"", 175},
		{"cecho \"We are not mad. In fact, I am happy.\\I wouldn't dare wish this upon anybody\\else, even for my own sake.\"", 175},
		{"cecho \"I do have a request however,\\ for you to consider.\\In your travels, be they near or far,\\keep us in mind.\"", 175},
		{"cecho \"Don't let our plight be forgotten,\\as that is a fate much worse than\\death.\"", 175},
		{"cecho \"And please, come visit us again.\\The souls lost within these walls.\"", 175},
		{"cecho \"We love visitors.\"", 175},
		{"quit"}
	},
	[22] = {
		{"cecho \"Sometimes the correct path is\\not the most obvious one.\""}
	},
	[50] = {
		{nil, 175},
		{"cecho \"Allow me to be the first to thank you\\for all of this.\"", 175},
		{"cecho \"You owed us nothing, and yet to gave\\us everything we could have ever\\wanted.\"", 175},
		{"cecho \"And for that, I am eternally grateful.\"", 175},
		{"cecho \"I must apologize for leaving a short\\message, as there is much to do\\now that we are free.\"", 175},
		{"cecho \"But know that you will always be within\\our hearts, as the one who\\set us free.\"", 175},
		{"cecho \"Thank you.\"", 175},
		{"quit"}
	},
	[64] = {
		{nil, 70},
		{"cecho \"...Why did you do that? Do you even\\realize what you've done?\"", 175},
		{"cecho \"Are you expecting some kind of reward?\\A secret?\"", 175},
		{"cecho \"Well I'm afraid you won't be getting one.\\You've broken the level.\\Ruined everything.\"", 175},
		{"cecho \"I want you to sit here and think about\\this. Reflect on the consequences of your\\actions. Then perhaps we can try again.\""},
	},
	[128] = {
		{"cecho \"Help\""}
	}
}

local HOUSE_CMD_BUFFER = {}
local HOUSE_CMD_TIMER = 0

addHook("LinedefExecute", function(line)
	if not (line and line.valid) then return end
	
	if not HOUSE_SCRIPTS[line.args[0]] then return end
	
	-- Clear the buffer
	HOUSE_CMD_BUFFER = {}
	
	-- Insert the commands into the buffer
	for _, cmd in ipairs(HOUSE_SCRIPTS[line.args[0]]) do
		table.insert(HOUSE_CMD_BUFFER, cmd)
	end
end, "HOUSESCR")

-- Reset the buffer every time the map is changed
addHook("MapChange", do
	HOUSE_CMD_BUFFER = {}
	HOUSE_CMD_TIMER = 0
end)

-- Run the buffer
addHook("ThinkFrame", do
	if HOUSE_CMD_TIMER then
		HOUSE_CMD_TIMER = $-1
		return
	end
	
	while HOUSE_CMD_BUFFER[1] do
		if HOUSE_CMD_BUFFER[1][1] then
			-- TODO: Make the quit command not quit on netgames
			if consoleplayer and consoleplayer.valid then
				COM_BufInsertText(consoleplayer, HOUSE_CMD_BUFFER[1][1])
			elseif server and server.valid then
				COM_BufInsertText(server, HOUSE_CMD_BUFFER[1][1])
			end
		end
		HOUSE_CMD_TIMER = HOUSE_CMD_BUFFER[1][2] or 0
		
		table.remove(HOUSE_CMD_BUFFER, 1)
		
		if HOUSE_CMD_TIMER then
			HOUSE_CMD_TIMER = $-2 -- This would be 1, but the timing becomes off
			break
		end
	end
end)

-- Make sure the command buffer is properly synced
-- TODO: This does NOT properly sync, figure out why
addHook("NetVars", function(net)
	HOUSE_CMD_BUFFER = net($)
	HOUSE_CMD_TIMER = net($)
end)
